var App = {
	classifyDegree: ['Constant','Linear','Quadratic','Cubic','Quartic','Quintic'],
	classifyTerms: ['Monomial','Binomial','Trinomial','Polynomial'],
	numericVals: [-3, -2, -1, 0, 1, 2, 3],
	absVals: [1,2,3], //absolute values of non-zero App.numericVals above
	setControlOptions: function(){
		$('#vocab-leadingCoefficient,#vocab-constantTerm').children().remove();
		for(var i=0; i<App.numericVals.length; i++){
			$('#vocab-leadingCoefficient,#vocab-constantTerm').append('<option>'+App.numericVals[i]+'</option>');
		}
		for(var i=0; i<App.classifyDegree.length; i++){
			$('#vocab-classifyDegree').append('<option>'+App.classifyDegree[i]+'</option>');
		}
		for(var i=0; i<App.classifyTerms.length; i++){
			$('#vocab-classifyTerms').append('<option>'+App.classifyTerms[i]+'</option>');
		}
	},
	randomIntFromTo: function(from,to){
	    return Math.floor(Math.random()*(to-from+1)+from);
	},
    randomFromArray: function(arr){
        return arr[App.randomIntFromTo(0,arr.length-1)];
    },
    shuffleArray: function(a) {
		var o = a.slice(); //slice with no params to copy all
        for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
        return o;
    },
	constructDisplayTerm: function(coefficient, exponent){
        var term = '';
        if(coefficient>0){
            term = '+';
        }
		if(coefficient==1){
			coefficient='';
		}
        if(coefficient==-1){
			coefficient='-';
		}
		if(exponent==1){
			exponent='';
		}
		term += coefficient+'x<sup>'+exponent+'</sup>';
        return term;
	},
	getRandomValues: function(){
		var valOfDegree = App.randomIntFromTo(0,App.classifyDegree.length-1);
		var numOfTerms = App.randomIntFromTo(1,valOfDegree+1);
		var display, lc, con;
		
		//constant
		display = App.randomFromArray(App.absVals);
		if(App.randomIntFromTo(0,1)){
			display = -1*display;
		}
		con = display;
		lc = 0;
		//non-constant
		
		if(valOfDegree){
			lc = con;
			con = 0; //might be changed later
			
			var displayTerms = [];
			displayTerms.push(App.constructDisplayTerm(lc, valOfDegree));
			
			var degrees = [0,1,2,3,4,5];
			degrees.splice(valOfDegree); //remove valOfDegree and degrees after that
			
			remainingTerms = numOfTerms-1;
			while(remainingTerms>0){
				remainingTerms--;
				var degIdx = App.randomIntFromTo(0,degrees.length-1);
				var degVal = degrees[degIdx];
				degrees.splice(degIdx,1);
				if(degVal){
					var coeff = 0;
					while(coeff==0){
						coeff=App.randomIntFromTo(-9,9);
					}
					displayTerms.push(App.constructDisplayTerm(coeff,degVal));
				}else{
					con = App.randomFromArray(App.absVals);
					if(App.randomIntFromTo(0,1)){
						con = -1*con;
						displayTerms.push(con);
					}else{
						displayTerms.push('+'+con);
					}
				}
			}
			
			//TODO shuffle displayTerms
			displayTerms = App.shuffleArray(displayTerms);
			display = displayTerms.join('');
			if(display.charAt(0)=='+'){
				display = display.substring(1); //remove leading +
			}
		}
		
        var classifyTermsIdx = numOfTerms-1;
        if(classifyTermsIdx>=App.classifyTerms.length){
            classifyTermsIdx = App.classifyTerms.length-1; //"Polynomial"
        }
		return {
			classifyDegree: App.classifyDegree[valOfDegree],
			classifyTerms: App.classifyTerms[classifyTermsIdx],
			leadingCoefficient: lc,
			constantTerm: con,
			display: display
		};
	},
	displayPolynomial: function(vals, target){
		$(target).html(vals.display);
	},
	scoreCount: 0,
	matchThese: {} //filled later
}
$(document).ready(function(){
	//bind controls
	$('#next').on('click',function(){
		$(this).hide();
		$('#check').show();
		$('label').removeClass('correct incorrect');
		App.matchThese = App.getRandomValues();
		App.displayPolynomial(App.matchThese, '#polynomial');
	});
	$('#check').on('click',function(){
		var singleChecks = ['leadingCoefficient','constantTerm'];
		for(var i=0; i<singleChecks.length; i++){
			var property = singleChecks[i];
			var label = $('label[for=vocab-'+property+']')
			if($('#vocab-'+property).val()==App.matchThese[property]){
				label.removeClass('incorrect');
				label.addClass('correct');
			}else{
				label.removeClass('correct');
				label.addClass('incorrect');
			}
		}
		var classifyLabel = $('label[for=vocab-classify');
		var classifyCorrect = true;
		if($('#vocab-classifyDegree').val()!=App.matchThese.classifyDegree){
			classifyCorrect = false;
		}
		if($('#vocab-classifyTerms').val()!=App.matchThese.classifyTerms){
			classifyCorrect = false;
		}
		if(classifyCorrect){
			classifyLabel.removeClass('incorrect');
			classifyLabel.addClass('correct');
		}else{
			classifyLabel.removeClass('correct');
			classifyLabel.addClass('incorrect');
		}
		if($('label.incorrect').length==0){ //nothing wrong
			$('#check').hide();
			$('#next').show();
			$('#scorecount').html(++App.scoreCount);
		}
	});
	
	//set up the page
	App.setControlOptions();
	$('#next').click(); 
});
